## hipercontracer 2.1.2~rc0

=== CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
PROJECT(hipercontracer LANGUAGES C CXX)

SET(BUILD_MAJOR "2")
SET(BUILD_MINOR "1")
SET(BUILD_PATCH "2~rc0")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})

# HiPerConTracer needs at least C++17!
SET(CMAKE_CXX_STANDARD 17)


#############################################################################
#### INSTALLATION_DIRECTORIES                                            ####
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
#### PACKAGING                                                           ####
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES "\\\\.git;\\\\.swp$;~$;\\\\.\\\\#;/\\\\#")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}[_-]")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "\\\\.cmake$|\\\\.make$|\\\\.log$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/CMakeCache\\\\.txt$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/(CMakeFiles|CMakeScripts|_CPack_Packages)/")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/package-version\\\\.h$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/packaging\\\\.conf$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/(po.*/|src.*/|)Makefile$")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


#############################################################################
#### UNINSTALL                                                           ####
#############################################################################

IF(NOT TARGET uninstall)
   CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)

   ADD_CUSTOM_TARGET(uninstall
      COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
ENDIF()


#############################################################################
#### OS DEPENDENT                                                        ####
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib" "/usr/local/lib/mariadb")
    INCLUDE_DIRECTORIES("/usr/local/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
#### OPTIONS                                                             ####
#############################################################################

INCLUDE(CheckIncludeFile)
INCLUDE(CheckStructHasMember)
INCLUDE(CheckCCompilerFlag)

OPTION(WITH_STATIC_LIBRARIES "Build static libraries"              0)
OPTION(WITH_SHARED_LIBRARIES "Build shared libraries"              1)
OPTION(STATIC_BUILD          "Build statically-linked executables" 0)
IF ((NOT WITH_STATIC_LIBRARIES) AND (NOT WITH_SHARED_LIBRARIES))
   MESSAGE(FATAL_ERROR "Static (WITH_STATIC_LIBRARIES) or shared (WITH_SHARED_LIBRARIES) libraries must be enabled!")
ENDIF()

IF (STATIC_BUILD)
   IF (WITH_SHARED_LIBRARIES)
      MESSAGE(FATAL_ERROR "WITH_STATIC_LIBRARIES=ON cannot be used with WITH_SHARED_LIBRARIES=ON!")
   ENDIF()
   MESSAGE("Building static executables")
   SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
   SET(Boost_USE_STATIC_LIBS       ON)
   SET(CMAKE_EXE_LINKER_FLAGS      "-static")
ELSE()
   IF (NOT WITH_SHARED_LIBRARIES)
      MESSAGE(FATAL_ERROR "STATIC_BUILD=OFF cannot be used with WITH_SHARED_LIBRARIES=OFF!")
   ENDIF()
ENDIF()

OPTION(WITH_HIPERCONTRACER  "Build HiPerConTracer"                      1)
OPTION(WITH_TRIGGER         "Build HiPerConTracer Trigger"              1)
OPTION(WITH_IMPORTER        "Build HiPerConTracer Importer"             1)
OPTION(WITH_SYNC            "Build HiPerConTracer Synchronisation Tool" 1)
OPTION(WITH_RTUNNEL         "Build HiPerConTracer Reverse Tunnel Tool"  1)
OPTION(WITH_NODE            "Build HiPerConTracer Node Tools"           1)
OPTION(WITH_COLLECTOR       "Build HiPerConTracer Collector Tools"      1)
OPTION(WITH_QUERY           "Build HiPerConTracer Query Tool"           1)
OPTION(WITH_RESULTS         "Build HiPerConTracer Results Tool"         1)
OPTION(WITH_VIEWER          "Build HiPerConTracer Viewer Tool"          1)
OPTION(WITH_DBSHELL         "Build HiPerConTracer Database Shell"       1)
OPTION(WITH_DBEAVER_TOOLS   "Build HiPerConTracer DBeaver Tools"        1)
OPTION(WITH_PIPE_CHECKSUM   "Build Pipe Checksum Tool"                  1)
OPTION(WITH_UDP_ECHO_SERVER "Build UDP Echo Server"                     1)
OPTION(WITH_ICONS           "Build HiPerConTracer icons and logo files" 1)


#############################################################################
#### COMPILER FLAGS                                                      ####
#############################################################################

IF(CMAKE_SYSTEM_PROCESSOR STREQUAL "riscv64")
   STRING(APPEND CMAKE_C_STANDARD_LIBRARIES   " -latomic")
   STRING(APPEND CMAKE_CXX_STANDARD_LIBRARIES " -latomic")
ENDIF()


#############################################################################
#### REQUIREMENTS                                                        ####
#############################################################################

# ====== Threads ============================================================
FIND_PACKAGE(Threads REQUIRED)

# ====== Boost ==============================================================
IF(CMAKE_VERSION VERSION_GREATER_EQUAL "3.30")
   # Use BoostConfig.cmake to find BOOST libraries, if possible.
   CMAKE_POLICY(SET CMP0167 NEW)
ENDIF()
FIND_PACKAGE(Boost REQUIRED COMPONENTS log date_time system thread iostreams filesystem program_options)
IF (NOT Boost_FOUND)
   MESSAGE(FATAL_ERROR "Cannot find Boost libraries!")
ELSE()
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF()
IF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
   ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)   # <<-- Required to handle BOOST Log link problem!
ENDIF()

# ====== INotify ============================================================
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
   SET(INotify_FOUND TRUE)
   SET(INotify_LIBRARIES "")
   SET(INotify_INCLUDE_DIRS "")
ELSE()
   FIND_LIBRARY(INotify_LIBRARIES NAMES inotify)
   FIND_PATH(INotify_INCLUDE_DIRS NAMES sys/inotify.h)
ENDIF()

# ====== libz ===============================================================
FIND_LIBRARY(Z_LIBRARY NAMES z)
IF (NOT Z_LIBRARY)
   MESSAGE(FATAL_ERROR
           " Cannot find Z library! Try:\n"
           " * Ubuntu/Debian: sudo apt install -y zlib1g-dev\n"
           " * Fedora:        sudo dnf install -y zlib-ng-compat-devel\n"
           " * SuSE:          sudo zypper install -y zlib-devel\n"
           " * Alpine:        sudo apk add zlib-ng-dev\n"
           " * FreeBSD:       sudo pkg install -y ???")
ENDIF()

# ====== libbz2 =============================================================
FIND_LIBRARY(BZ2_LIBRARY NAMES bz2)
IF (NOT BZ2_LIBRARY)
   MESSAGE(FATAL_ERROR
           " Cannot find BZ2 library! Try:\n"
           " * Ubuntu/Debian: sudo apt install -y libbz2-dev\n"
           " * Fedora:        sudo dnf install -y bzip2-devel\n"
           " * SuSE:          sudo zypper install -y libbz2-devel\n"
           " * Alpine:        sudo apk add bzip2-dev\n"
           " * FreeBSD:       sudo pkg install -y bzip2")
ENDIF()

# ====== liblzma ============================================================
FIND_LIBRARY(LZMA_LIBRARY NAMES lzma)
IF (NOT LZMA_LIBRARY)
   MESSAGE(FATAL_ERROR
           " Cannot find LZMA library! Try:\n"
           " * Ubuntu/Debian: sudo apt install -y liblzma-dev\n"
           " * Fedora:        sudo dnf install -y xz-devel\n"
           " * SuSE:          sudo zypper install -y xz-devel\n"
           " * Alpine:        sudo apk add xz-dev\n"
           " * FreeBSD:       sudo pkg install -y lzmalib")
ENDIF()

# ====== libzstd ============================================================
FIND_LIBRARY(ZSTD_LIBRARY NAMES zstd)
IF (NOT ZSTD_LIBRARY)
   MESSAGE(FATAL_ERROR
           " Cannot find ZSTD library! Try:\n"
           " * Ubuntu/Debian: sudo apt install -y libzstd-dev\n"
           " * Fedora:        sudo dnf install -y libzstd-devel\n"
           " * SuSE:          sudo zypper install -y libzstd-devel\n"
           " * Alpine:        sudo apk add libzstd-devel\n"
           " * FreeBSD:       sudo pkg install -y zstd")
ENDIF()

# ====== C-ARES =============================================================
# IF (WITH_HIPERCONTRACER)
#    FIND_LIBRARY(CARES_LIBRARY NAMES cares libcares)
#    IF (NOT CARES_LIBRARY)
#       MESSAGE(FATAL_ERROR
#             " Cannot find C-ARES DNS resolver library! Try:\n"
#             " * Ubuntu/Debian: sudo apt install -y libc-ares-dev\n"
#             " * Fedora:        sudo dnf install -y c-ares-devel\n"
#             " * SuSE:          sudo zypper install -y c-ares-devel\n"
#             " * Alpine:        sudo apk add c-ares-dev\n"
#             " * FreeBSD:       sudo pkg install -y c-ares")
#    ENDIF()
# ENDIF()

# ====== libcrypto ==========================================================
IF (WITH_PIPE_CHECKSUM)
   FIND_LIBRARY(CRYPTO_LIBRARY crypto libcrypto)
   IF (NOT CRYPTO_LIBRARY)
      MESSAGE(FATAL_ERROR
              " Cannot find libcrypto library! Try:\n"

=== src/CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### VERSION FILE                                                        ####
#############################################################################

CONFIGURE_FILE (
   "${CMAKE_CURRENT_SOURCE_DIR}/package-version.h.in"
   "${CMAKE_CURRENT_BINARY_DIR}/package-version.h"
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


#############################################################################
#### LIBRARIES                                                           ####
#############################################################################

# ====== libhpctio ==========================================================
LIST(APPEND libhpctio_headers
   compressortype.h
   inputstream.h
   logger.h
   outputstream.h
   tools.h
)
LIST(APPEND libhpctio_sources
   compressortype.cc
   inputstream.cc
   logger.cc
   outputstream.cc
   tools.cc
)

INSTALL(FILES ${libhpctio_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/hipercontracer)

IF (WITH_STATIC_LIBRARIES)
   ADD_LIBRARY(libhpctio-static STATIC ${libhpctio_sources})
ENDIF()
IF (WITH_SHARED_LIBRARIES)
   ADD_LIBRARY(libhpctio-shared SHARED ${libhpctio_sources})
ENDIF()
FOREACH(TYPE shared;static)
   IF ( (("${TYPE}" STREQUAL "static") AND (WITH_STATIC_LIBRARIES)) OR
      (("${TYPE}" STREQUAL "shared") AND (WITH_SHARED_LIBRARIES)) )
      SET_TARGET_PROPERTIES(libhpctio-${TYPE} PROPERTIES OUTPUT_NAME hpctio CLEAN_DIRECT_OUTPUT 1)
      SET_TARGET_PROPERTIES(libhpctio-${TYPE} PROPERTIES
         VERSION   ${BUILD_VERSION}
         SOVERSION ${BUILD_MAJOR}
      )
      TARGET_LINK_LIBRARIES (libhpctio-${TYPE} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${LZMA_LIBRARY} ${BZ2_LIBRARY} ${Z_LIBRARY})
      INSTALL(TARGETS libhpctio-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
   ENDIF()
ENDFOREACH()

# ====== libhipercontracer ==================================================
IF (WITH_HIPERCONTRACER)
   LIST(APPEND libhipercontracer_headers
      check.h
      destinationinfo.h
      iomodule-base.h
      iomodule-icmp.h
      iomodule-udp.h
      # jitter.h
      ping.h
      resultentry.h
      resultswriter.h
      service.h
      traceroute.h
   )
   LIST(APPEND libhipercontracer_sources
      assure.cc
      check.cc
      destinationinfo.cc
      internet16.cc
      iomodule-base.cc
      iomodule-icmp.cc
      iomodule-udp.cc
      # jitter.cc
      # jitter-rfc3550.cc
      ping.cc
      resultentry.cc
      resultswriter.cc
      service.cc
      traceroute.cc
      traceserviceheader.cc
   )

   INSTALL(FILES ${libhipercontracer_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/hipercontracer)

   IF (WITH_STATIC_LIBRARIES)
      ADD_LIBRARY(libhipercontracer-static STATIC ${libhipercontracer_sources})
   ENDIF()
   IF (WITH_SHARED_LIBRARIES)
      ADD_LIBRARY(libhipercontracer-shared SHARED ${libhipercontracer_sources})
   ENDIF()
   FOREACH(TYPE shared;static)
      IF ( (("${TYPE}" STREQUAL "static") AND (WITH_STATIC_LIBRARIES)) OR
         (("${TYPE}" STREQUAL "shared") AND (WITH_SHARED_LIBRARIES)) )
         SET_TARGET_PROPERTIES(libhipercontracer-${TYPE} PROPERTIES OUTPUT_NAME hipercontracer CLEAN_DIRECT_OUTPUT 1)
         SET_TARGET_PROPERTIES(libhipercontracer-${TYPE} PROPERTIES
            VERSION   ${BUILD_VERSION}
            SOVERSION ${BUILD_MAJOR}
         )
         TARGET_LINK_LIBRARIES (libhipercontracer-${TYPE} libhpctio-${TYPE} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
         INSTALL(TARGETS libhipercontracer-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
      ENDIF()
   ENDFOREACH()
ENDIF()

# ====== libuniversalimporter ==================================================
IF (WITH_IMPORTER)
   LIST(APPEND libuniversalimporter_headers
      database-configuration.h
      database-statement.h
      databaseclient-base.h
      importer-configuration.h
      reader-base.h
      results-exception.h
      universal-importer.h
      worker.h
   )
   LIST(APPEND libuniversalimporter_sources
      database-configuration.cc
      database-statement.cc
      databaseclient-base.cc
      importer-configuration.cc
      reader-base.cc
      universal-importer.cc
      worker.cc
   )

   IF (ENABLE_BACKEND_DEBUG)
      LIST(APPEND libuniversalimporter_headers databaseclient-debug.h)
      LIST(APPEND libuniversalimporter_sources databaseclient-debug.cc)
      SET_PROPERTY(SOURCE database-configuration.cc APPEND PROPERTY COMPILE_DEFINITIONS ENABLE_BACKEND_DEBUG)
   ENDIF()
   IF (ENABLE_BACKEND_MARIADB)
      LIST(APPEND libuniversalimporter_headers databaseclient-mariadb.h)
      LIST(APPEND libuniversalimporter_sources databaseclient-mariadb.cc)
      SET_PROPERTY(SOURCE database-configuration.cc APPEND PROPERTY COMPILE_DEFINITIONS ENABLE_BACKEND_MARIADB)
   ENDIF()
   IF (ENABLE_BACKEND_POSTGRESQL)
      LIST(APPEND libuniversalimporter_headers databaseclient-postgresql.h)
      LIST(APPEND libuniversalimporter_sources databaseclient-postgresql.cc)
      SET_PROPERTY(SOURCE database-configuration.cc APPEND PROPERTY COMPILE_DEFINITIONS ENABLE_BACKEND_POSTGRESQL)
   ENDIF()
   IF (ENABLE_BACKEND_MONGODB)
      LIST(APPEND libuniversalimporter_headers databaseclient-mongodb.h)
      LIST(APPEND libuniversalimporter_sources databaseclient-mongodb.cc)
      SET_PROPERTY(SOURCE database-configuration.cc APPEND PROPERTY COMPILE_DEFINITIONS ENABLE_BACKEND_MONGODB)
   ENDIF()


   INSTALL(FILES ${libuniversalimporter_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/universalimporter)

   IF (WITH_STATIC_LIBRARIES)
      ADD_LIBRARY(libuniversalimporter-static STATIC ${libuniversalimporter_sources})
   ENDIF()
   IF (WITH_SHARED_LIBRARIES)
      ADD_LIBRARY(libuniversalimporter-shared SHARED ${libuniversalimporter_sources})
   ENDIF()
   FOREACH(TYPE shared;static)
      IF ( (("${TYPE}" STREQUAL "static") AND (WITH_STATIC_LIBRARIES)) OR
           (("${TYPE}" STREQUAL "shared") AND (WITH_SHARED_LIBRARIES)) )
         SET_TARGET_PROPERTIES(libuniversalimporter-${TYPE} PROPERTIES OUTPUT_NAME universalimporter CLEAN_DIRECT_OUTPUT 1)
         SET_TARGET_PROPERTIES(libuniversalimporter-${TYPE} PROPERTIES
            VERSION   ${BUILD_VERSION}
            SOVERSION ${BUILD_MAJOR}
         )
         TARGET_INCLUDE_DIRECTORIES(libuniversalimporter-${TYPE} PUBLIC ${LIBMARIADB_INCLUDE_DIR} ${LIBMONGOC_INCLUDE_DIR} ${LIBBSON_INCLUDE_DIR} ${INotify_INCLUDE_DIRS})
         TARGET_LINK_LIBRARIES(libuniversalimporter-${TYPE} libhpctio-${TYPE} ${Boost_LIBRARIES} ${LIBMARIADB_LIBRARY} ${LIBPQXX_LIBRARY} ${LIBMONGOC_LIBRARY} ${LIBBSON_LIBRARY} ${INotify_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
         INSTALL(TARGETS libuniversalimporter-${TYPE} DESTINATION ${CMAKE_INSTALL_LIBDIR})
      ENDIF()
   ENDFOREACH()
ENDIF()


#############################################################################
#### PROGRAMS                                                            ####
#############################################################################

IF (STATIC_BUILD)
   SET(libraryType static)
ELSE()
   SET(libraryType shared)
ENDIF()

# ====== HiPerConTracer =====================================================
IF (WITH_HIPERCONTRACER)
   ADD_EXECUTABLE(hipercontracer hipercontracer.cc)
   TARGET_LINK_LIBRARIES(hipercontracer libhipercontracer-${libraryType} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
   INSTALL(TARGETS     hipercontracer     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES       hipercontracer.1   DESTINATION         ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES       hipercontracer.xml DESTINATION         ${CMAKE_INSTALL_DATAROOTDIR}/mime/packages)
   INSTALL(FILES       hipercontracer.bib DESTINATION         ${CMAKE_INSTALL_DATADIR}/hipercontracer)

   INSTALL(FILES       hipercontracer.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      hipercontracer)
   IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      INSTALL(FILES hipercontracer.service       DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hipercontracer@.service      DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hipercontracer-12345678.conf DESTINATION /etc/hipercontracer)
   ENDIF()
ENDIF()

# ====== HiPerConTracer Trigger =============================================
IF (WITH_TRIGGER)
   ADD_EXECUTABLE(hpct-trigger hpct-trigger.cc)
   TARGET_LINK_LIBRARIES(hpct-trigger libhipercontracer-${libraryType} ${Boost_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
   INSTALL(TARGETS hpct-trigger RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES       hpct-trigger.1 DESTINATION   ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES       hpct-trigger.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      hpct-trigger)
   IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      INSTALL(FILES hpct-trigger.service       DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hpct-trigger@.service      DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hpct-trigger-87654321.conf DESTINATION /etc/hipercontracer)
   ENDIF()
ENDIF()


# ====== HiPerConTracer Sync Tool ===========================================
IF (WITH_SYNC)
   INSTALL(PROGRAMS hpct-sync DESTINATION ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES hpct-sync.1  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES       hpct-sync.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      hpct-sync)
   IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      INSTALL(FILES hpct-sync.service DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hpct-sync.timer   DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
      INSTALL(FILES hpct-sync.conf    DESTINATION /etc/hipercontracer)
   ENDIF()
ENDIF()


# ====== HiPerConTracer Reverse Tunnel Tool =================================
IF (WITH_RTUNNEL)
   INSTALL(PROGRAMS    hpct-rtunnel   DESTINATION ${CMAKE_INSTALL_BINDIR})
   INSTALL(FILES       hpct-rtunnel.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
   INSTALL(FILES       hpct-rtunnel.bash-completion
           DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
           RENAME      hpct-rtunnel)
   IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      INSTALL(FILES hpct-rtunnel.service  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
   ENDIF()
ENDIF()

=== freebsd/hipercontracer/Makefile ===
PORTNAME=	hipercontracer
DISTVERSION=	2.1.2~rc0
CATEGORIES=	benchmarks
MASTER_SITES=	https://www.nntb.no/~dreibh/hipercontracer/download/

MAINTAINER=	thomas.dreibholz@gmail.com
COMMENT=	High-Performance Connectivity Tracer (HiPerConTracer)
WWW=		https://www.nntb.no/~dreibh/hipercontracer/

LICENSE=	GPLv3+
LICENSE_FILE=	${WRKSRC}/COPYING

LIB_DEPENDS=	libboost_date_time.so:devel/boost-libs \
		libboost_filesystem.so:devel/boost-libs \
		libboost_iostreams.so:devel/boost-libs \
		libboost_log.so:devel/boost-libs \
		libboost_program_options.so:devel/boost-libs \
		libboost_system.so:devel/boost-libs \
		libboost_thread.so:devel/boost-libs \
		libinotify.so:devel/libinotify
RUN_DEPENDS=	getopt>=0:misc/getopt

USES=		cmake compiler:c++20-lang desktop-file-utils python \
		shared-mime-info shebangfix ssl tar:xz
USE_LDCONFIG=	yes

SHEBANG_FILES=	src/results-examples/r-install-dependencies \
		src/results-examples/r-ping-example \
		src/results-examples/r-traceroute-example \
		src/TestDB/generate-test-certificates

# Work-around for build issue on ARM (https://bugs.freebsd.org/285706):
MAKE_ENV=	OMP_NUM_THREADS=1

PLIST_SUB=	DISTVERSION=${DISTVERSION}

OPTIONS_DEFINE=		COLLECTOR DBEAVERTOOLS DBSHELL ICONS IMPMARIADB \
			IMPMONGO IMPORTER IMPPGSQL NODE QUERYTOOL RESULTSTOOL \
			RTUNNEL SYNC TRIGGER UDPECHO VIEWERTOOL
OPTIONS_DEFAULT=	COLLECTOR DBEAVERTOOLS DBSHELL ICONS IMPMARIADB \
			IMPMONGO IMPORTER IMPPGSQL NODE QUERYTOOL RESULTSTOOL \
			RTUNNEL SYNC TRIGGER UDPECHO VIEWERTOOL
COLLECTOR_DESC=		Build HiPerConTracer Collector Tools
DBEAVERTOOLS_DESC=	Build DBeaver Tools
DBSHELL_DESC=		Build DBShell
ICONS_DESC=		Build Icons and Logo Files
IMPMARIADB_DESC=	Enable MariaDB/MySQL support for HiPerConTracer Importer Tool
IMPMONGO_DESC=		Enable MongoDB support for HiPerConTracer Importer Tool
IMPORTER_DESC=		Build HiPerConTracer Importer Tool
IMPPGSQL_DESC=		Enable PostgreSQL support for HiPerConTracer Importer Tool
NODE_DESC=		Build HiPerConTracer Node Tools
QUERYTOOL_DESC=		Build HiPerConTracer Query Tool
RESULTSTOOL_DESC=	Build HiPerConTracer Results Tool
RTUNNEL_DESC=		Build HiPerConTracer Reverse Tunnel Tool
SYNC_DESC=		Build HiPerConTracer Synchronisation Tool
TRIGGER_DESC=		Build HiPerConTracer Trigger Tool
UDPECHO_DESC=		Build UDP Echo Server
VIEWERTOOL_DESC=	Build HiPerConTracer Viewer Tool

COLLECTOR_CMAKE_BOOL=		WITH_COLLECTOR
DBEAVERTOOLS_CMAKE_BOOL=	WITH_DBEAVER_TOOLS
DBSHELL_CMAKE_BOOL=		WITH_DBSHELL
ICONS_BUILD_DEPENDS=		gm:graphics/GraphicsMagick \
				gs:print/ghostscript10 \
				pdf2svg:graphics/pdf2svg
ICONS_CMAKE_BOOL=		WITH_ICONS
IMPMARIADB_LIB_DEPENDS=		libmariadb.so:databases/mariadb106-client
IMPMARIADB_CMAKE_BOOL=		ENABLE_BACKEND_MARIADB
IMPMONGO_LIB_DEPENDS=		libbson-1.0.so:devel/libbson \
				libmongoc-1.0.so:devel/mongo-c-driver
IMPMONGO_CMAKE_BOOL=		ENABLE_BACKEND_MONGODB
IMPORTER_CMAKE_BOOL=		WITH_IMPORTER
IMPPGSQL_LIB_DEPENDS=		libpqxx.so:databases/postgresql-libpqxx
IMPPGSQL_CMAKE_BOOL=		ENABLE_BACKEND_POSTGRESQL
NODE_CMAKE_BOOL=		WITH_NODE
QUERYTOOL_CMAKE_BOOL=		WITH_QUERY
RESULTSTOOL_CMAKE_BOOL=		WITH_RESULTS
RTUNNEL_CMAKE_BOOL=		WITH_RTUNNEL
SYNC_CMAKE_BOOL=		WITH_SYNC
TRIGGER_CMAKE_BOOL=		WITH_TRIGGER
UDPECHO_CMAKE_BOOL=		WITH_UDP_ECHO_SERVER
VIEWERTOOL_CMAKE_BOOL=		WITH_VIEWER

.include <bsd.port.mk>

=== src/NoSQL/CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### EXAMPLES                                                            ####
#############################################################################

INSTALL(FILES
           README-MongoDB.md
           R-query-example.R
           mongodb-database.ms
           mongodb-schema.ms
           mongodb-test.ms
           mongodb-users.ms
           nornet-tools.R
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/NoSQL)

=== src/SQL/CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### EXAMPLES                                                            ####
#############################################################################

INSTALL(FILES
           README-MySQL+MariaDB.md
           README-PostgreSQL.md
           mariadb-database.sql
           mariadb-delete-all-rows.sql
           mariadb-functions.sql
           mariadb-procedures.sql
           mariadb-schema.sql
           mariadb-test.sql
           mariadb-users.sql
           mariadb-views.sql
           postgresql-database.sql
           postgresql-delete-all-rows.sql
           postgresql-functions.sql
           postgresql-procedures.sql
           postgresql-schema.sql
           postgresql-test.sql
           postgresql-users.sql
           postgresql-views.sql
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/SQL)

=== src/TestDB/CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### EXAMPLES                                                            ####
#############################################################################

INSTALL(FILES
           CertificateHelper.py
           README.md
           hpct-users.conf.example
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/TestDB)
INSTALL(PROGRAMS
           0-make-configurations
           1-install-database
           2-initialise-database
           3-test-database
           4-clean-database
           5-perform-hpct-importer-test
           6-perform-hpct-query-test
           9-uninstall-database
           generate-test-certificates
           name-in-etc-hosts
           run-full-test
           test-tls-connection
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/TestDB)

=== src/results-examples/CMakeLists.txt ===
# ==========================================================================
#     _   _ _ ____            ____          _____
#    | | | (_)  _ \ ___ _ __ / ___|___  _ _|_   _| __ __ _  ___ ___ _ __
#    | |_| | | |_) / _ \ '__| |   / _ \| '_ \| || '__/ _` |/ __/ _ \ '__|
#    |  _  | |  __/  __/ |  | |__| (_) | | | | || | | (_| | (_|  __/ |
#    |_| |_|_|_|   \___|_|   \____\___/|_| |_|_||_|  \__,_|\___\___|_|
#
#       ---  High-Performance Connectivity Tracer (HiPerConTracer)  ---
#                 https://www.nntb.no/~dreibh/hipercontracer/
# ==========================================================================
#
# High-Performance Connectivity Tracer (HiPerConTracer)
# Copyright (C) 2015-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### EXAMPLES                                                            ####
#############################################################################

FILE(GLOB_RECURSE EXAMPLE_RESULTS "*.hpct*" "*.results*")

# This does not work with the tarball package:
# EXECUTE_PROCESS(COMMAND         git ls-files .
#                 COMMAND         grep -E "\\.(hpct|results)\\..*$"
#                 OUTPUT_VARIABLE EXAMPLE_RESULTS)
# FILE(GLOB_RECURSE EXAMPLE_RESULTS "*.hpct*" "*.results*")
# MESSAGE("Example results files: ${EXAMPLE_RESULTS}")

INSTALL(FILES HiPerConTracer.R
              ${EXAMPLE_RESULTS}
              README.md
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/results-examples)
INSTALL(PROGRAMS r-install-dependencies
                 r-ping-example
                 r-traceroute-example
        DESTINATION ${CMAKE_INSTALL_DATADIR}/hipercontracer/results-examples)

=== debian/changelog ===
hipercontracer (2.1.2~rc0-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Updated standards version to 4.7.2.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 10 Oct 2025 12:14:10 +0200

=== debian/control ===
Source: hipercontracer
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <dreibh@simula.no>
Homepage: https://www.nntb.no/~dreibh/hipercontracer/
Vcs-Git: https://github.com/dreibh/hipercontracer.git
Vcs-Browser: https://github.com/dreibh/hipercontracer
Build-Depends: cmake (>= 3.10),
               debhelper-compat (= 13),
               ghostscript,
               graphicsmagick,
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-log-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libbz2-dev,
               liblzma-dev,
               libmariadb-dev,
               libmongoc-dev,
               libpqxx-dev,
               libzstd-dev,
               pdf2svg,
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: hipercontracer
Architecture: any
Depends: hipercontracer-common,
         iproute2,
         libhipercontracer2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ethtool,
            hipercontracer-viewer
Suggests: hipercontracer-collector,
          hipercontracer-dbeaver-tools,
          hipercontracer-dbshell,
          hipercontracer-importer,
          hipercontracer-node,
          hipercontracer-query,
          hipercontracer-results,
          hipercontracer-sync,
          hipercontracer-trigger,
          hipercontracer-udp-echo-server,
          netperfmeter,
          td-system-info
Description: High-Performance Connectivity Tracer (HiPerConTracer)
 High-Performance Connectivity Tracer (HiPerConTracer) is a Ping/Traceroute
 measurement framework. HiPerConTracer denotes the actual measurement
 tool. It performs regular Ping and Traceroute runs among sites, featuring:
 multi-transport-protocol support (ICMP, UDP); multi-homing and parallelism
 support; handling of load balancing in the network; multi-platform
 support (currently Linux and FreeBSD); high-precision (nanoseconds)
 timing support (Linux timestamping, both software and hardware); a
 library (shared/static) to integrate measurement functionality into other
 software (libhipercontracer); open source and written in a performance-
 and portability-focused programming language (C++) with only limited
 dependencies.
 .
 Furthermore, the HiPerConTracer Framework furthermore provides additional
 tools for helping to obtain, process, collect, store, and retrieve
 measurement data: HiPerConTracer Viewer Tool for displaying the contents
 of results files; Results Tool for merging and converting results files,
 e.g. to create a Comma-Separated Value (CSV) file; Sync Tool for copying data
 from a measurement node (vantage point) to a remote HiPerConTracer Collector
 server (via RSync/SSH); Reverse Tunnel Tool for maintaining a reverse SSH
 tunnel from a remote measurement node to a HiPerConTracer Collector server;
 Collector/Node Tools for simplifying the setup of HiPerConTracer Nodes and a
 HiPerConTracer Collector server; Trigger Tool for triggering HiPerConTracer
 measurements in the reverse direction; Importer Tool for storing measurement
 data from results files into SQL or NoSQL databases. Currently, database
 backends for MariaDB/MySQL PostgreSQL, MongoDB) are provided; Query
 Tool for querying data from a database and storing it into a results
 file; Database Shell as simple command-line front-end for the underlying
 database backends; Database Tools with some helper scripts to e.g. to join
 HiPerConTracer database configurations into an existing DBeaver (a popular
 SQL database GUI application) configuration; UDP Echo Server as UDP Echo
 (RFC 862) protocol endpoint; Wireshark dissector for HiPerConTracer packets.
 .
 This package contains the actual HiPerConTracer program.

Package: hipercontracer-common
Architecture: all
Depends: acl,
         passwd,
         ${misc:Depends}
Suggests: python3,
          r-base-core
Description: HiPerConTracer common files
 High-Performance Connectivity Tracer (HiPerConTracer) is a Ping/Traceroute
 measurement framework. HiPerConTracer denotes the actual measurement
 tool. It performs regular Ping and Traceroute runs among sites, featuring:
 multi-transport-protocol support (ICMP, UDP); multi-homing and parallelism
 support; handling of load balancing in the network; multi-platform
 support (currently Linux and FreeBSD); high-precision (nanoseconds)
 timing support (Linux timestamping, both software and hardware); a
 library (shared/static) to integrate measurement functionality into other
 software (libhipercontracer); open source and written in a performance-
 and portability-focused programming language (C++) with only limited
 dependencies.
 .
 Furthermore, the HiPerConTracer Framework furthermore provides additional
 tools for helping to obtain, process, collect, store, and retrieve
 measurement data: HiPerConTracer Viewer Tool for displaying the contents
 of results files; Results Tool for merging and converting results files,
 e.g. to create a Comma-Separated Value (CSV) file; Sync Tool for copying data
 from a measurement node (vantage point) to a remote HiPerConTracer Collector
 server (via RSync/SSH); Reverse Tunnel Tool for maintaining a reverse SSH
 tunnel from a remote measurement node to a HiPerConTracer Collector server;
 Collector/Node Tools for simplifying the setup of HiPerConTracer Nodes and a
 HiPerConTracer Collector server; Trigger Tool for triggering HiPerConTracer
 measurements in the reverse direction; Importer Tool for storing measurement
 data from results files into SQL or NoSQL databases. Currently, database
 backends for MariaDB/MySQL PostgreSQL, MongoDB) are provided; Query
 Tool for querying data from a database and storing it into a results
 file; Database Shell as simple command-line front-end for the underlying
 database backends; Database Tools with some helper scripts to e.g. to join
 HiPerConTracer database configurations into an existing DBeaver (a popular
 SQL database GUI application) configuration; UDP Echo Server as UDP Echo
 (RFC 862) protocol endpoint; Wireshark dissector for HiPerConTracer packets.
 .
 The package contains common files for HiPerConTracer and the HiPerConTracer
 Tools packages.

Package: libhpctio2
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: I/O library of HiPerConTracer
 High-Performance Connectivity Tracer (HiPerConTracer) is a Ping/Traceroute
 measurement framework. HiPerConTracer denotes the actual measurement
 tool. It performs regular Ping and Traceroute runs among sites, featuring:
 multi-transport-protocol support (ICMP, UDP); multi-homing and parallelism
 support; handling of load balancing in the network; multi-platform
 support (currently Linux and FreeBSD); high-precision (nanoseconds)
 timing support (Linux timestamping, both software and hardware); a
 library (shared/static) to integrate measurement functionality into other
 software (libhipercontracer); open source and written in a performance-
 and portability-focused programming language (C++) with only limited
 dependencies.
 .
 Furthermore, the HiPerConTracer Framework furthermore provides additional
 tools for helping to obtain, process, collect, store, and retrieve
 measurement data: HiPerConTracer Viewer Tool for displaying the contents
 of results files; Results Tool for merging and converting results files,
 e.g. to create a Comma-Separated Value (CSV) file; Sync Tool for copying data
 from a measurement node (vantage point) to a remote HiPerConTracer Collector
 server (via RSync/SSH); Reverse Tunnel Tool for maintaining a reverse SSH
 tunnel from a remote measurement node to a HiPerConTracer Collector server;
 Collector/Node Tools for simplifying the setup of HiPerConTracer Nodes and a
 HiPerConTracer Collector server; Trigger Tool for triggering HiPerConTracer
 measurements in the reverse direction; Importer Tool for storing measurement
 data from results files into SQL or NoSQL databases. Currently, database
 backends for MariaDB/MySQL PostgreSQL, MongoDB) are provided; Query
 Tool for querying data from a database and storing it into a results
 file; Database Shell as simple command-line front-end for the underlying
 database backends; Database Tools with some helper scripts to e.g. to join
 HiPerConTracer database configurations into an existing DBeaver (a popular
 SQL database GUI application) configuration; UDP Echo Server as UDP Echo
 (RFC 862) protocol endpoint; Wireshark dissector for HiPerConTracer packets.
 .
 This library shares I/O functions commonly used by libhipercontracer and
 libuniversalimporter.

Package: libhpctio-dev
Section: libdevel
Architecture: any
Breaks: libhipercontracer-dev (<< ${source:Version}),
        libuniversalimporter-dev (<< ${source:Version})
Depends: libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-log-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libhpctio2 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for the HiPerConTracer I/O library
 High-Performance Connectivity Tracer (HiPerConTracer) is a Ping/Traceroute
 measurement framework. HiPerConTracer denotes the actual measurement
 tool. It performs regular Ping and Traceroute runs among sites, featuring:
 multi-transport-protocol support (ICMP, UDP); multi-homing and parallelism
 support; handling of load balancing in the network; multi-platform
 support (currently Linux and FreeBSD); high-precision (nanoseconds)
 timing support (Linux timestamping, both software and hardware); a
 library (shared/static) to integrate measurement functionality into other
 software (libhipercontracer); open source and written in a performance-
 and portability-focused programming language (C++) with only limited
 dependencies.
 .
 Furthermore, the HiPerConTracer Framework furthermore provides additional
 tools for helping to obtain, process, collect, store, and retrieve
 measurement data: HiPerConTracer Viewer Tool for displaying the contents
 of results files; Results Tool for merging and converting results files,
 e.g. to create a Comma-Separated Value (CSV) file; Sync Tool for copying data
 from a measurement node (vantage point) to a remote HiPerConTracer Collector
 server (via RSync/SSH); Reverse Tunnel Tool for maintaining a reverse SSH
 tunnel from a remote measurement node to a HiPerConTracer Collector server;
 Collector/Node Tools for simplifying the setup of HiPerConTracer Nodes and a
 HiPerConTracer Collector server; Trigger Tool for triggering HiPerConTracer
 measurements in the reverse direction; Importer Tool for storing measurement
 data from results files into SQL or NoSQL databases. Currently, database
 backends for MariaDB/MySQL PostgreSQL, MongoDB) are provided; Query
 Tool for querying data from a database and storing it into a results
 file; Database Shell as simple command-line front-end for the underlying
 database backends; Database Tools with some helper scripts to e.g. to join
 HiPerConTracer database configurations into an existing DBeaver (a popular
 SQL database GUI application) configuration; UDP Echo Server as UDP Echo
 (RFC 862) protocol endpoint; Wireshark dissector for HiPerConTracer packets.
 .
 This package provides header files for the HiPerConTracer I/O library.

Package: libhipercontracer2
Section: libs
Architecture: any
Depends: libhpctio2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: API library of HiPerConTracer
 High-Performance Connectivity Tracer (HiPerConTracer) is a Ping/Traceroute
 measurement framework. HiPerConTracer denotes the actual measurement
 tool. It performs regular Ping and Traceroute runs among sites, featuring:
 multi-transport-protocol support (ICMP, UDP); multi-homing and parallelism

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DWITH_STATIC_LIBRARIES=ON -DWITH_SHARED_LIBRARIES=ON

# Use upstream ChangeLog for installation
override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

# Do not enable services by default
override_dh_installsystemd:
	dh_installsystemd --no-enable

=== debian/tests/control ===
Tests: 10-hipercontracer-icmp
Restrictions: needs-sudo, needs-internet, allow-stderr
Depends: hipercontracer

Tests: 11-hipercontracer-udp
Restrictions: needs-sudo, needs-internet, allow-stderr
Depends: hipercontracer,
         hipercontracer-udp-echo-server

Tests: 20-hpct-results
Restrictions: allow-stderr
Depends: hipercontracer-common,
         hipercontracer-results

Tests: 30-dbeaver-tools
Restrictions: allow-stderr
Depends: hipercontracer,
         hipercontracer-dbeaver-tools,
         mariadb-client | default-mysql-client,
         postgresql-client,
         pwgen

Tests: 50-full-database-test
Restrictions: isolation-machine, breaks-testbed, needs-sudo, needs-internet, allow-stderr
Depends: hipercontracer-dbeaver-tools,
         hipercontracer-dbshell,
         hipercontracer-importer,
         hipercontracer-query,
         hipercontracer-results,
         pwgen,
         python3-netifaces,
         rsync
